// Generated by CoffeeScript 1.10.0
(function() {
  var HGAPI, HGCommandServer, HGRepo, Parsers, api;

  HGCommandServer = require("./HGCommandServer");

  HGRepo = require("./HGRepo");

  Parsers = require("./parsers");


  /*
  The public facing API of the node-hg module exposes convenience methods for various common Mercurial tasks.
   */

  HGAPI = (function() {
    function HGAPI() {}

    HGAPI.prototype.init = function(initPath, opts, done) {
      return HGRepo.MakeTempRepo(function(err, repo) {
        if (err) {
          return done(err);
        }
        return repo.init(initPath, done);
      });
    };

    HGAPI.prototype.clone = function(from, to, opts, done) {
      return HGRepo.MakeTempRepo(function(err, repo) {
        if (err) {
          return done(err);
        }
        return repo.clone(from, to, opts, done);
      });
    };

    HGAPI.prototype.add = function(path, opts, done) {
      var repo;
      repo = new HGRepo(path);
      return repo.add(opts, done);
    };

    HGAPI.prototype.commit = function(path, opts, done) {
      var repo;
      repo = new HGRepo(path);
      return repo.commit(opts, done);
    };

    HGAPI.prototype.summary = function(path, opts, done) {
      var repo;
      repo = new HGRepo(path);
      return repo.summary(opts, done);
    };

    HGAPI.prototype.log = function(path, opts, done) {
      var repo;
      repo = new HGRepo(path);
      return repo.log(opts, done);
    };

    HGAPI.prototype.version = function(done) {
      var repo;
      repo = new HGRepo(null);
      return repo.version(done);
    };

    HGAPI.prototype.makeParser = function(done) {
      return api.version(function(err, out) {
        return done(err, new Parsers(Parsers.version(out)));
      });
    };

    return HGAPI;

  })();

  api = new HGAPI();

  api.HGCommandServer = HGCommandServer;

  api.HGRepo = HGRepo;

  api.Parsers = Parsers;

  module.exports = api;

}).call(this);
